xbasc(0);
//****************************************************
//*                                                  * 
//*          Description des fonctions necessaires   *
//*                                 pouet                 *
//****************************************************




// definition du cout

E=[5.9623
,6.998
,8.4363
,9.9111
,11.018
,12.126
,13.233
,14.541
,15.848
,17.156
,18.463
,19.771];

alpha=1000; //cout de la backstop technology
nu=3;
theta=0.0000526; 
M0=360;     // concentration initiale 
Minf=274;   // concentration preindustrielle 
rho=0.05;   // taux d'actualisation 
sigma=0.01; // taux de disparition du CO2 dans les puits 
delta=10;   // pas de temps 
beta=0.38;  // taux d'absorption des emissions dans l'atmosphere
neta=38.05;
Ms=400;


deff('y=Kappa(t)','y=18000*exp(0.02*delta*t)');

deff('y=Lambda(t)','y=0.25+0.75*exp(-0.01*delta*t)');

deff('y=xsi(m)','y=exp(-((m-Ms)/38.05)^2)');
deff('y=xsi_m(m)','y=-2*(m-Ms)/(38.05^2)*exp(-((m-Ms)/38.05)^2)');


//-------------------------- L et ses gradients-------------------------------

deff('y=L(a,x,t)','y=(alpha*E(t+1)*a^nu*Lambda(t)+Kappa(t)*xsi(x(2)))/(1+rho)^(delta*(t))');

deff('y=L_cmd(a,x,t)','y=alpha*E(t+1)*nu*a^(nu-1)*Lambda(t)/(1+rho)^(delta*t)');

deff('y=L_etat(a,x,t)','y(1)=0,y(2)=Kappa(t)*xsi_m(x(2))/(1+rho)^(delta*t)');


// ------------------------f et ses gradients----------------------------------


deff('y=f(a,x,t)','y(1)=a,y(2)=x(2)+10*(beta*E(t+1)*(1-a)-sigma*(x(2)-Minf))');

//         ATTENTION ! 
//	     
//	     dfj
//	     --- = res[j+N*i]
//	     dxi
 
deff('y=f_etat(a,x,t)','y=zeros(2,2),y(1,1)=0,y(2,1)=0,y(1,2)=0,y(2,2)=1-sigma*delta');

deff('y=f_cmd(a,x,t)','y(1)=1,y(2)=-beta*E(t+1)*delta');



// ------------------------phi et ses gradients--------------------------------

deff('y=phi(x,t)','y=Kappa(t)*xsi(x(2))/(1+rho)^(delta*t)');

deff('y=phi_etat(x,t)','y(1)=0,y(2)=Kappa(t)*xsi_m(x(2))/(1+rho)^(delta*t)')

Ugms560=[0.06
,0.08
,0.11
,0.16
,0.22
,0.31
,0.41
,0.53
,0.61
,0.66
,0.65
,0.00]

Ugms655=[0.02
,0.03
,0.04
,0.05
,0.07
,0.10
,0.14
,0.19
,0.26
,0.36
,0.42
,0.00]

Ugms750=[0.00
,0.00
,0.01
,0.01
,0.01
,0.02
,0.02
,0.03
,0.04
,0.06
,0.08
,0.00]


// definition des parametres du probleme
e0=[0;360];
xb=zeros(1,12);
xh=zeros(1,12)+1;
x0=rand(1,12);


// oh que c'est joli
couleur=2;


[Uopt,Eopt]=dynoptim("L","L_cmd","L_etat","f","f_cmd","f_etat","phi","phi_etat",xb,xh,x0,e0);


T=[0:11];
T=1990+10*T;
plot2d(T,Uopt,couleur,"111","abatement au cours du temps ",[1990,0,2100,1],[10,10,10,10]);
//plot2d(T,Ugms750',5,"111","abatement au cours du temps ",[1990,0,2100,1],[10,10,10,10]);

















