function [uopt,eopt,critopt,gradopt]=dynoptim(name_L,name_f,name_phi,U_low,U_init,U_high,X_init,varargin)
//------------------------------------------------------------------
// discrete time optimal control problem without state constraints 
// name_xxx : name of Scilab functions which describe the problem 
// i.e L, f and phi and their derivatives 
//        min J(u) 
// U_low <= u <= U_high               t=0..T-1
// where J(u)= sum ( L(u[t],x[t],t),t=0:T-1) + phi(u[T],x[T],T)
// and the dynamics follows 
// x[t+1]=f(u[t],x[t],t)
// the time horizon is T=size(U_init) 
//---------------------------------------------------------------------------
// tranmit the problem function names to internal code 
doc_setf(name_L(1),name_L(2),name_L(3),name_f(1),name_f(2),name_f(3),name_phi(1),name_phi(2));
// set default optim parameters 
nap = 200;
iter= 200;
epsf= 0.000E+00;
epsg= 0.4441E-15;
epsx= 0*U_init+0.0000E+00;
info_optim = 0
algo= 'qn'

[lhs,rhs]=argn(0)


deff('b=is_dyn_key(mot)','b=...
    (mot==''ar'')|(mot==''algo'')');


// verification  des arguments optionnels

if rhs < 7 then
  error("at least one argument is missing",1001)
elseif rhs >7 then
  for i=1:rhs-7
    if (varargin(i) == "ar") then
      if rhs<7+i+5 then
	error("after ar 5 arguments expected",1001)
      else
	for j=1:5
	  if is_dyn_key(varargin(i+j)) then
	    error("after ar 5 arguments expected",1001)
	  end
	end
	i=i+5
      end
    elseif (varargin(i) == "algo") then
      if rhs<7+i+1 then
	error("after algo 2 arguments expected",1001)
      else
	if is_dyn_key(varargin(i+1)) then
	  error("after algo 2 arguments expected",1001)
	end
	i=i+1
      end
    end
  end
end    

//recuperation des arguments optionnels

for i=1:rhs-7
  if (varargin(i) == "ar") then
    nap=varargin(i+1);
    dynsc_iter=varargin(i+2);
    epsf=varargin(i+3);
    epsg=varargin(i+4);
    epsx=varargin(i+5);
    i=i+5;
  elseif varargin(i) == "algo"
    algo=varargin(i+1);
    i=i+1;
  end
end

if rhs == 7 
   [fopt,uopt,gopt]=optim(dyn_ora,'b',U_low,U_high,U_init,imp=2) 
else 
   [fopt,uopt,gopt]=optim(dyn_ora,'b',U_low,U_high,U_init,algo,...
			 'ar',nap,iter,epsg,epsf,epsx,imp=2)
end
// recompute the value function, its gradient and optimal trajectory 
[critopt,gradopt,eopt]=doc_J(uopt,X_init);

function [fo,go,ind]=dyn_ora(U,ind)
// Utility function which can be given as an optim argument 
[fo,go,eo]=doc_J(U,X_init);











