#include <string.h>
#include "stack-c.h"
#include "cout_dyn.h"
#include "doc_int_sc.h"

/***************************************************
 * deal with errors in scilab functions 
 ***************************************************/

#include <setjmp.h>
static  jmp_buf Jcenv; 

#define MySciString(ibegin,name,mlhs,mrhs) \
  if( ! C2F(scistring)(ibegin,name,mlhs,mrhs,strlen(name))) \
       { longjmp(Jcenv,-1);return 0; } 

static int returned_from_longjump ;


/*********************************************************************
 *                       INTERFACE POUR SCILAB                       *
 *                                                                   *
 *               [f,grf,lambda]=J(cmd,e0,einf,esup,alpha,c,p)        *
 *********************************************************************/

int interfaceJ_sc(char* fname)
{
  static int ierr;
  /* les variables d'entres*/
  static int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4,m5,n5,l5,m6,n6,l6,m7,n7,l7;
  /* les outputs */
  static int m8,n8,l8,m9,n9,l9,m10,n10,l10;
  static int minlhs=0, minrhs=7, maxlhs=3,maxrhs=7;
 
  CheckRhs(minrhs,maxrhs);
  CheckLhs(minlhs,maxlhs);

  /*          on recupere les variables entrees
  ------------------------------------------------*/
  GetRhsVar(1,"d",&m1,&n1,&l1);
  GetRhsVar(2,"d",&m2,&n2,&l2);
  GetRhsVar(3,"d",&m3,&n3,&l3);//einf
  GetRhsVar(4,"d",&m4,&n4,&l4);//esup
  GetRhsVar(5,"d",&m5,&n5,&l5);//alpha
  GetRhsVar(6,"d",&m6,&n6,&l6);//c
  GetRhsVar(7,"d",&m7,&n7,&l7);//p
  /*  n1 est le nombre de pas de temps
      m1 est la taille de la commande
      m2 est la dimension de l'etat*/
 
  /*         on cree les variables de sorties
  ------------------------------------------------*/
  n8=1;
  m8=1;
  CreateVar(8,"d",&m8,&n8,&l8);
 
  n9=n1;
  m9=m1;
  CreateVar(9,"d",&m9,&n9,&l9);
  
  /* l'etat est de dimension N*(T+1)*/
  n10=n1+1;
  m10=m2;
  CreateVar(10,"d",&m10,&n10,&l10);

  /* le dernier parametre sert a dire si c'est la derniere fois 
     que l'on s'en sert*/
  

  if (( returned_from_longjump = setjmp(Jcenv)) != 0 )
    {
      Scierror(999,"%s: Internal error \r\n",fname);
      return 0;
    } 


  J_sc_GRAD(stk(l1),&n1,&m1,&m2,stk(l2),stk(l3),stk(l4),stk(l5),stk(l6)[0],stk(l7),stk(l10),stk(l9),stk(l8),0);

  /*test(stk(l1),stk(l2),stk(l3),&m1,&m2);*/
 
  LhsVar(1)=8; 
  LhsVar(2)=9;
  LhsVar(3)=10;
  
  return 0;
}








/*********************************************************************
 *                       INTERFACE POUR SCILAB                       *
 *                                                                   *
 *                         Setf(L,phi,f)                             *
 *********************************************************************/


/*  les noms des fonctions scilab sont dans les variables suivantes
---------------------------------------------------------------------*/

char phi_name[nlgh+1],phi_etat_name[nlgh+1];
char f_name[nlgh+1],f_cmd_name[nlgh+1],f_etat_name[nlgh+1];
char L_name[nlgh+1],L_cmd_name[nlgh+1],L_etat_name[nlgh+1];



int interfaceSetf_sc(char* fname)
{
  static int ierr;
  static int m1,n1,l1,m2,n2,l2,m3,n3,l3;/* les noms de L et de ses derivees  */
  static int m4,n4,l4,m5,n5,l5,m6,n6,l6;/* les noms de f et de ses derivees  */
  static int m7,n7,l7,m8,n8,l8;/* les noms de phi et de ses derivees*/
  
  static int minlhs=0, minrhs=8, maxlhs=1,maxrhs=8;

  CheckRhs(minrhs,maxrhs);
  CheckLhs(minlhs,maxlhs);

  /*          on recupere les variables entrees
  ------------------------------------------------*/
  GetRhsVar(1,"c",&m1,&n1,&l1); /* le nom de L        */
  GetRhsVar(2,"c",&m2,&n2,&l2); /* le nom de L_cmd    */
  GetRhsVar(3,"c",&m3,&n3,&l3); /* le nom de L_etat   */
  GetRhsVar(4,"c",&m4,&n4,&l4); /* le nom de f        */
  GetRhsVar(5,"c",&m5,&n5,&l5); /* le nom de f_cmd    */
  GetRhsVar(6,"c",&m6,&n6,&l6); /* le nom de f_etat   */
  GetRhsVar(7,"c",&m7,&n7,&l7); /* le nom de phi      */
  GetRhsVar(8,"c",&m8,&n8,&l8); /* le nom de phi_etat */
 
  
  strncpy(L_name,cstk(l1),nlgh);
  strncpy(L_cmd_name,cstk(l2),nlgh);
  strncpy(L_etat_name,cstk(l3),nlgh);
  strncpy(f_name,cstk(l4),nlgh);
  strncpy(f_cmd_name,cstk(l5),nlgh);
  strncpy(f_etat_name,cstk(l6),nlgh);
  strncpy(phi_name,cstk(l7),nlgh);
  strncpy(phi_etat_name,cstk(l8),nlgh);


  return 0;
}
  


/*********************************************************************
 *                       INTERFACE POUR SCILAB                       *
 *                                                                   *
 *                  [theta,etat]=T(cmd,e0,einf,esup,alpha)           *
 *********************************************************************/

int interfaceT_sc(char* fname)
{
  static int ierr;
  /* les variables d'entres*/
  static int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4,m5,n5,l5;
  /* les outputs */
  static int m6,n6,l6,m7,n7,l7;
  static int minlhs=0, minrhs=5, maxlhs=2,maxrhs=5;
 
  CheckRhs(minrhs,maxrhs);
  CheckLhs(minlhs,maxlhs);

  /*          on recupere les variables entrees
  ------------------------------------------------*/
  GetRhsVar(1,"d",&m1,&n1,&l1);
  GetRhsVar(2,"d",&m2,&n2,&l2);
  GetRhsVar(3,"d",&m3,&n3,&l3);//einf
  GetRhsVar(4,"d",&m4,&n4,&l4);//esup
  GetRhsVar(5,"d",&m5,&n5,&l5);//alpha
 
  /*  n1 est le nombre de pas de temps
      m1 est la taille de la commande
      m2 est la dimension de l'etat*/
 
  /*         on cree les variables de sorties
  ------------------------------------------------*/
  n6=1;
  m6=2*m2*(n1+1);
  CreateVar(6,"d",&m6,&n6,&l6);
  
  /* l'etat est de dimension N*(T+1)*/
  n7=(n1+1);
  m7=m2;
  CreateVar(7,"d",&m7,&n7,&l7);

  /* le dernier parametre sert a dire si c'est la derniere fois 
     que l'on s'en sert*/
  
  
  if (( returned_from_longjump = setjmp(Jcenv)) != 0 )
    {
      Scierror(999,"%s: Internal error \r\n",fname);
      return 0;
    } 

  THETA(stk(l1),&n1,&m1,&m2,stk(l2),stk(l3),stk(l4),stk(l5),stk(l7),stk(l6),0);
  
  LhsVar(1)=6; 
  LhsVar(2)=7;
  //fprintf(fid,"%s \n","fin du calcul"); 
  return 0;
}



/*********************************************************************
 *                       INTERFACE POUR SCILAB                       *
 *                                                                   *
 *                             washup()                              *
 *********************************************************************/




int interfacewashup_sc(char* fname)
{
  
  static int ierr,un=1;
  static double p=1;
  static int minlhs=1, minrhs=0, maxlhs=1,maxrhs=0;

  CheckRhs(minrhs,maxrhs);
  CheckLhs(minlhs,maxlhs);

  /* le dernier parametre sert a dire que c'est la derniere fois 
     que l'on s'en sert*/
  
  if (( returned_from_longjump = setjmp(Jcenv)) != 0 )
    {
      Scierror(999,"%s: Internal error \r\n",fname);
      return 0;
    } 

  J_sc_GRAD(&p,&un,&un,&un,&p,&p,&p,&p,p,&p,&p,&p,&p,1);
  return 0;

}





/*************************** interface sciex **************************/






int sciex3_sc(char fct[nlgh+1],int begin,double* cmd,double* etat,int* temps,double* res,int* n_cmd,int* n_etat, int* n_res)
{

  // les variables utilisees sont les 11, 12 et 13
  static int l1,l2,l3;
  // on utilise trois arguments et on ne renvoie qu'un resultat
  static int ibegin,mlhs=1,mrhs=3;
  
  int i,un=1;
  
  ibegin=begin;
  CreateVar(ibegin,"d",n_cmd,&un,&l1);
  for(i=0;i < *n_cmd;i++)
    {
      stk(l1)[i]=cmd[i];

    }
  CreateVar(ibegin+1,"d",n_etat,&un,&l2);
  for(i=0;i < *n_etat;i++)
    {
      stk(l2)[i]=etat[i];

    }

  CreateVar(ibegin+2,"d",&un,&un,&l3);
  stk(l3)[0]=*temps;

 
  /* execute la fonction fct */
  
  MySciString(&ibegin,fct,&mlhs,&mrhs);
 
  for(i=0;i<n_res[0];i++)
    { 
      res[i]=stk(l1)[i];

    }
  return 0;
}

int sciex2_sc(char fct[nlgh+1],int begin,double* etat,int* temps,double* res,int* n_etat, int* n_res)
{

  // les variables utilisees sont les 11 et 12
  static int l1,l2;
  // on utilise trois arguments et on ne renvoie qu'un resultat
  static int ibegin,mlhs=1,mrhs=2;

  int i,un=1;
  
  ibegin=begin;
  CreateVar(ibegin,"d",n_etat,&un,&l1);
  for(i=0;i < *n_etat;i++)
    {
      stk(l1)[i]=etat[i];

    }
  CreateVar(ibegin+1,"d",&un,&un,&l2);
  stk(l2)[0]=temps[0];

  
  /* execute la fonction fct */
  
  MySciString(&ibegin,fct,&mlhs,&mrhs);
  for(i=0;i<n_res[0];i++)
    { 
      res[i]=stk(l1)[i];

    }
  
  return 0;
}




























