#include <math.h>
#include "fonctions.h"
#include "stack-c.h"
#include "doc_int_sc.h"


/**********************************************************************
 *                             fonction de cout                        *
 **********************************************************************/



void L_sc(double* cmd,double* etat,int* temps,double* etatinf,double* etatsup,double* alpha,double c,double* p,double* res,int* n_cmd,int* n_etat)
{
  int R=1,pass,i=0;
  int N=*n_etat;
  int K=*temps;
  //on execute la macro L_name: resultat de taille 1
  pass=sciex3_sc(L_name,BeginVar,cmd,etat,temps,res,n_cmd,n_etat,&R);
  
  //rajout pour Lagrangien augment
  for(i=0;i<n_etat[0];i++)
    {
      if((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c>0)
	*res+=c/2*pow((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c,2);
      if((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c>0)
	*res+=c/2*pow((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c,2);
    }
}
 

void L_sc_cmd(double* cmd,double* etat,int* temps,double* etatinf,double* etatsup,double* alpha,double c,double* p,double* res,int* n_cmd,int* n_etat)
{
  int pass;
  //on execute la macro L_cmd_name: resultat de taille *n_cmd
  pass=sciex3_sc(L_cmd_name,BeginVar,cmd,etat,temps,res,n_cmd,n_etat,n_cmd);
  
}

void L_sc_etat(double* cmd,double* etat,int* temps,double* etatinf,double* etatsup,double* alpha,double c,double* p,double* res,int* n_cmd,int* n_etat)
{
  int pass,i=0;
  int N=*n_etat;
  int K=*temps;
  //on execute la macro L_etat_name: resultat de taille *n_etat
  pass=sciex3_sc(L_etat_name,BeginVar,cmd,etat,temps,res,n_cmd,n_etat,n_etat);
  
  //rajout pour Lagrangien augment
 
  for(i=0;i<n_etat[0];i++)
    {
      if((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c>0)
	res[i]+=c*((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c)/alpha[i];
      if((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c>0)
	*res+=-c*((etatinf[i]-etat[i+N*K])/alpha[i]+p[i+N]/c)/alpha[i];
    } 
}



/**********************************************************************
 *                 fonction de contraite finale                        *
 **********************************************************************/




void phi_sc(double* etat,int* temps,double* etatinf,double* etatsup,double* alpha,double c,double* p,double* res,int* n_etat)
{
  int R=1,pass,i=0;
  int N=*n_etat;
  int K=*temps;
  //on execute la macro L_name: resultat de taille 1
  pass=sciex2_sc(phi_name,BeginVar,etat,temps,res,n_etat,&R);
  
  // rajout pour le lagrangien augmente

  for(i=0;i<n_etat[0];i++)
    {
      if((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c>0)
	*res+=c/2*pow((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c,2);
      if((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c>0)
	*res+=c/2*pow((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c,2);
    } 

}

void phi_sc_etat(double* etat,int* temps,double* etatinf,double* etatsup,double* alpha,double c,double* p,double* res,int* n_etat)
{
  int pass,i=0;
  int N=*n_etat;
  int K=*temps;
  //on execute la macro L_etat_name: resultat de taille *n_etat
  pass=sciex2_sc(phi_etat_name,BeginVar,etat,temps,res,n_etat,n_etat);

  for(i=0;i<n_etat[0];i++)
    {
      if((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c>0)
	res[i]+=c*((etat[i]-etatsup[i+N*K])/alpha[i]+p[i]/c)/alpha[i];
	
      if((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c>0)
	*res+=-c*((etatinf[i+N*K]-etat[i])/alpha[i]+p[i+N]/c)/alpha[i];
    } 
}




/**********************************************************************
 *                               dynamique                             *
 **********************************************************************/




void f_sc(double* cmd,double* etat,int* temps,double* res,int* n_cmd,int* n_etat)

{
  int pass;
  //on execute la macro L_etat_name: resultat de taille *n_etat

  pass=sciex3_sc(f_name,BeginVar,cmd,etat,temps,res,n_cmd,n_etat,n_etat);
}

void f_sc_etat(double* cmd,double* etat,int* temps,double* res,int* n_cmd,int* n_etat)
{
  int pass,R=*n_etat*(*n_etat);
  //on execute la macro L_etat_name: resultat de taille *n_etat*(*n_etat)
  pass=sciex3_sc(f_etat_name,BeginVar,cmd,etat,temps,res,n_cmd,n_etat,&R);
                        
}

void f_sc_cmd(double* cmd,double* etat,int* temps,double* res,int* n_cmd,int* n_etat)
{
  int pass,R=*n_etat*(*n_cmd);
  //on execute la macro f_cmd_name: resultat de taille *n_etat*(*n_cmd)
  pass=sciex3_sc(f_cmd_name,BeginVar,cmd,etat,temps,res,n_cmd,n_etat,&R);
}

















