// small test file 
// instantaneous cost function and its derivatives 
exec ../loader.sce 

deff('y=L(u,x,t)','y=u^2+ x^2')
deff('y=L_cmd(u,x,t)','y=2*u')
deff('y=L_etat(u,x,t)','y=2*x')

// system dynamics and its derivatives 

deff('y=f(u,x,t)','y=u+x')
deff('y=f_etat(u,x,t)','y=1')
deff('y=f_cmd(u,x,t)','y=1')

// final cost and its derivatives 

deff('y=phi(x,t)','y=x^2')
deff('y=phi_etat(x,t)','y=2*x')

// initial state 
x0=[1];
// control bounds and initial guess 
// ub <= u <= uh and u0 initial value for u 

ub= -10;
uh= +10;
u0= 0;

// calling dynoptim 
nom_L=["L","L_cmd","L_etat"];
nom_f=["f","f_cmd","f_etat"];
nom_phi=["phi","phi_etat"];

[Uopt,Eopt,Jopt,Gradopt]=dynoptim(nom_L,nom_f,nom_phi,ub,u0,uh,x0);

// check result 
if abs(Uopt +0.5) > 1.e-2 then pause,end 




