// small test file 
// instantaneous cost function and its derivatives 
exec ../loader.sce 

deff('y=L(u,x,t)','y=u^2')
deff('y=L_cmd(u,x,t)','y=2*u')
deff('y=L_etat(u,x,t)','y=[0,0]')

// system dynamics and its derivatives 

deff('y=f(u,x,t)','y=B*u+A*x')
deff('y=f_etat(u,x,t)','y=A')
deff('y=f_cmd(u,x,t)','y=B')

// final cost and its derivatives 
// Q symetric 

deff('y=phi(x,t)','y= 0.5* x''*Q*x')
deff('y=phi_etat(x,t)','y= Q*x')

// initial state 
x0=[1;2];
// control bounds and initial guess 
// ub <= u <= uh and u0 initial value for u 

ub= -10;
uh= +10;
u0= 0;

Q=diag([1,2]);
B=[3;4];
A=[1,2;3,4];

// calling dynoptim 
nom_L=["L","L_cmd","L_etat"];
nom_f=["f","f_cmd","f_etat"];
nom_phi=["phi","phi_etat"];

[Uopt,Eopt,Jopt,Gradopt]=dynoptim(nom_L,nom_f,nom_phi,ub,u0,uh,x0);

a=1+ 0.5*B'*Q*B ;
b=0.5*( x0'*A'*Q*B + B'*Q*A*x0);
c=0.5* x0'*A'*Q*A*x0 ;
// solve u^2 a + u*b + c ;
uopt = -b/(2*a);
deff('y=cost(u)','y=L(u,x0,0) + phi(f(u,x0,0))')
jopt=cost(uopt) ;

if abs(uopt-Uopt) > 1.e-2 then pause,end 
if abs(jopt-Jopt) > 1.e-2 then pause,end 


ub= 1.0;
uh= +10;
u0= 0;
[Uopt,Eopt,Jopt,Gradopt]=dynoptim(nom_L,nom_f,nom_phi,ub,u0,uh,x0);

if abs(1-Uopt) > 1.e-2 then pause,end 
